---
{{ _auto_generated_preamble }}
# Source: provisioner/templates/serviceaccount.yaml
apiVersion: v1
kind: ServiceAccount
metadata:
  name: local-storage
  namespace: {{ k8s_local_storage_static_namespace | to_json }}
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
---
# Source: provisioner/templates/configmap.yaml
apiVersion: v1
kind: ConfigMap
metadata:
  name: local-storage-config
  namespace: {{ k8s_local_storage_static_namespace | to_json }}
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
data:
  storageClassMap: |
    {{ k8s_local_storage_static_storageclass_name | to_json  }}:
       hostDir: {{ k8s_local_storage_static_discovery_directory | to_json }}
       mountDir: {{ k8s_local_storage_static_discovery_directory | to_json }}
       blockCleanerCommand:
         - "/scripts/shred.sh"
         - "2"
       volumeMode: Filesystem
       fsType: ext4
       namePattern: "*"
---
# Source: provisioner/templates/rbac.yaml
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
  name: local-storage-node-clusterrole
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
rules:
- apiGroups: [""]
  resources: ["nodes"]
  verbs: ["get"]
---
# Source: provisioner/templates/rbac.yaml
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: local-storage-pv-binding
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
subjects:
- kind: ServiceAccount
  name: local-storage
  namespace: {{ k8s_local_storage_static_namespace | to_json }}
roleRef:
  kind: ClusterRole
  name: system:persistent-volume-provisioner
  apiGroup: rbac.authorization.k8s.io
---
# Source: provisioner/templates/rbac.yaml
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: local-storage-node-binding
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
subjects:
- kind: ServiceAccount
  name: local-storage
  namespace: {{ k8s_local_storage_static_namespace | to_json }}
roleRef:
  kind: ClusterRole
  name: local-storage-node-clusterrole
  apiGroup: rbac.authorization.k8s.io
---
# Source: provisioner/templates/daemonset.yaml
apiVersion: apps/v1
kind: DaemonSet
metadata:
  name: local-storage
  namespace: {{ k8s_local_storage_static_namespace | to_json }}
  labels:
    app.kubernetes.io/name: local-storage
    app.kubernetes.io/instance: local-storage
    app.kubernetes.io/version: {{ k8s_local_storage_static_version | to_json }}
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: local-storage
      app.kubernetes.io/instance: local-storage
      app.kubernetes.io/version: v2.3.4
  template:
    metadata:
      labels:
        app.kubernetes.io/name: local-storage
        app.kubernetes.io/instance: local-storage
        app.kubernetes.io/version: v2.3.4
{# unfortunately, we made a mistake: we put the /version in the selector.
as the selector is immutable, we cannot change the version field without causing
massive chaos. As a workaround, we freeze the version field of the pods and
add a new actually-version field for informational purposes. #}
        app.kubernetes.io/actually-version: {{ k8s_local_storage_static_version | to_json }}
    spec:
      priorityClassName: system-node-critical
      serviceAccountName: local-storage
{% if k8s_local_storage_static_nodeplugin_toleration %}
      tolerations:
        - operator: Exists
{% if k8s_local_storage_static_nodeplugin_toleration != True %}
          key: {{ k8s_local_storage_static_nodeplugin_toleration | to_json }}
{% endif %}
{% endif %}
      containers:
        - image: {{ "k8s.gcr.io/sig-storage/local-volume-provisioner:%s" | format (k8s_local_storage_static_version) | to_json }}
          name: provisioner
          securityContext:
            privileged: true
          env:
          - name: MY_NODE_NAME
            valueFrom:
              fieldRef:
                fieldPath: spec.nodeName
          - name: MY_NAMESPACE
            valueFrom:
              fieldRef:
                fieldPath: metadata.namespace
          - name: JOB_CONTAINER_IMAGE
            value: {{ "k8s.gcr.io/sig-storage/local-volume-provisioner:%s" | format (k8s_local_storage_static_version) | to_json }}
          volumeMounts:
            - mountPath: /etc/provisioner/config
              name: provisioner-config
              readOnly: true
            - mountPath: /dev
              name: provisioner-dev
            - mountPath: {{ k8s_local_storage_static_discovery_directory | to_json }}
              name: local-storage
              mountPropagation: "HostToContainer"
      volumes:
        - name: provisioner-config
          configMap:
            name: local-storage-config
        - name: provisioner-dev
          hostPath:
            path: /dev
        - name: local-storage
          hostPath:
            path: {{ k8s_local_storage_static_discovery_directory | to_json }}
